package com.sd.business.service.inventory;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.service.BaseService;
import com.sd.business.entity.inventory.dto.InventoryFinishedDto;
import com.sd.business.entity.inventory.dto.InventoryFinishedSelectDto;
import com.sd.business.entity.inventory.po.InventoryFinished;
import com.sd.business.entity.inventory.vo.InventoryFinishedVo;
import com.sd.business.entity.order.po.OrderSku;

import java.util.List;


/**
 * <p>
 * 成品仓库 服务类
 * </p>
 *
 * @author
 * @since 2023-12-11
 */
public interface InventoryFinishedService extends BaseService<InventoryFinished> {

    /**
     * 成品仓库分页
     */
    Page<InventoryFinishedVo> getPage(InventoryFinishedSelectDto dto);

    /**
     * 成品仓库明细
     */
    InventoryFinishedVo detail(Long id);

    /**
     * 成品仓库新增
     */
    void add(InventoryFinishedDto dto);

    /**
     * 成品仓库编辑
     */
    void edit(InventoryFinishedDto dto);

    /**
     * 成品仓库删除
     */
    void delete(Long id);

    /**
     * 生产入库
     */
    void productionWarehousing(List<Long> orderIdList);

    /**
     * 成品仓sku规格出入库
     */
    void inOut(List<InventoryFinished> list, boolean isIn);

    /**
     * 删除订单回滚库存
     *
     * @param orderId 订单id
     */
    void removeOrder(Long orderId);

    /**
     * 锁定无源成品库存
     */
    boolean lockNoSourceStorage(List<? extends OrderSku> orderSkuList);

}
